"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var FirebaseAdminCoreModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.FirebaseAdminCoreModule = void 0;
const common_1 = require("@nestjs/common");
const app_1 = require("firebase-admin/app");
const firebase_admin_constant_1 = require("./firebase-admin.constant");
const auth_1 = require("firebase-admin/auth");
const messaging_1 = require("firebase-admin/messaging");
const remote_config_1 = require("firebase-admin/remote-config");
const firestore_1 = require("firebase-admin/firestore");
const storage_1 = require("firebase-admin/storage");
const PROVIDERS = [
    {
        cls: auth_1.Auth,
        get: auth_1.getAuth,
    },
    {
        cls: messaging_1.Messaging,
        get: messaging_1.getMessaging,
    },
    {
        cls: remote_config_1.RemoteConfig,
        get: remote_config_1.getRemoteConfig,
    },
    {
        cls: firestore_1.Firestore,
        get: firestore_1.getFirestore,
    },
    {
        cls: storage_1.Storage,
        get: storage_1.getStorage,
    },
];
const EXPORTS = [...PROVIDERS.map((provider) => provider.cls)];
let FirebaseAdminCoreModule = FirebaseAdminCoreModule_1 = class FirebaseAdminCoreModule {
    static forRoot(options) {
        const firebaseAdminModuleOptions = {
            provide: firebase_admin_constant_1.FIREBASE_ADMIN_MODULE_OPTIONS,
            useValue: options,
        };
        const app = (0, app_1.getApps)().length === 0 ? (0, app_1.initializeApp)(options) : (0, app_1.getApps)()[0];
        const providers = this.createProviders(app);
        return {
            module: FirebaseAdminCoreModule_1,
            providers: [firebaseAdminModuleOptions, ...providers],
            exports: [...EXPORTS],
        };
    }
    static createProviders(app) {
        return PROVIDERS.map((ProviderService) => ({
            provide: ProviderService.cls,
            useFactory: () => ProviderService.get(app),
        }));
    }
    static forRootAsync(options) {
        const firebaseAdminModuleOptions = {
            provide: firebase_admin_constant_1.FIREBASE_ADMIN_MODULE_OPTIONS,
            useFactory: options.useFactory,
            inject: options.inject || [],
        };
        const providers = this.createAsyncProviders();
        return {
            module: FirebaseAdminCoreModule_1,
            imports: options.imports,
            providers: [firebaseAdminModuleOptions, ...providers],
            exports: [...EXPORTS],
        };
    }
    static createAsyncProviders() {
        return PROVIDERS.map((ProviderService) => ({
            provide: ProviderService.cls,
            useFactory: (options) => {
                const app = (0, app_1.getApps)().length === 0 ? (0, app_1.initializeApp)(options) : (0, app_1.getApps)()[0];
                return ProviderService.get(app);
            },
            inject: [firebase_admin_constant_1.FIREBASE_ADMIN_MODULE_OPTIONS],
        }));
    }
};
FirebaseAdminCoreModule = FirebaseAdminCoreModule_1 = __decorate([
    (0, common_1.Global)(),
    (0, common_1.Module)({})
], FirebaseAdminCoreModule);
exports.FirebaseAdminCoreModule = FirebaseAdminCoreModule;
